<?php
	class Timer {
		var $startTime;
		var $endTime;
		function start() {
			$this->startTime = gettimeofday();
		}
		function stop() {
			$this->endTime = gettimeofday();
		}
		function elapsed() {
			return (($this->endTime["sec"] - $this->startTime["sec"]) * 1000000 + ($this->endTime["usec"] - $this->startTime["usec"])) / 1000000;
		}
	}
	$timer = new Timer();
	$timer->start();
	include("../settings-data.php");
	include("../lib.php");
	session_start();
	checkPermissions($login, $password);
	if (file_exists("../dictionary-data.php"))
		include("../dictionary-data.php");
	if (!isset($censor))
		$censor = null;
	$contentCnt = sizeof($censor);
	$messageToPage = "50";
	$inverse = true;
?>
<html>
<head>
<title>admbook :: version <?=$constant['version']?></title>
<?php
	if ($constant['charset'] != "")
	{
?>
<meta http-equiv="Content-Type" content="text/html; charset=<?=$constant['charset']?>"/>
<?php
	}
?>
<script language="JavaScript" src="../script.js" type="text/javascript"></script>
<link href="../style.css" type="text/css" rel="stylesheet"/>
<style type="text/css">
<!--
.text {
	font : 8pt "Verdana","Arial Cyr", "Arial","Tahoma","Helvetica", sans-serif;
	color : <?=$constant['text-color']?>
}

.link {
	font : 8pt "Verdana","Arial Cyr", "Arial","Tahoma","Helvetica", sans-serif;
	color : <?=$constant['link-color']?>
}

.messagetext {
	font : 8pt "Verdana","Arial Cyr", "Arial","Tahoma","Helvetica", sans-serif;
	color : <?=$constant['message-text-color']?>
}

.messagelink {
	font : 8pt "Verdana","Arial Cyr", "Arial","Tahoma","Helvetica", sans-serif;
	color : <?=$constant['message-link-color']?>
}

.admintext {
	font : 8pt "Verdana","Arial Cyr", "Arial","Tahoma","Helvetica", sans-serif;
	color : <?=$constant['admin-message-text-color']?>
}

.adminlink {
	font : 8pt "Verdana","Arial Cyr", "Arial","Tahoma","Helvetica", sans-serif;
	color : <?=$constant['admin-message-link-color']?>
}

.headertext {
	font : 8pt "Verdana","Arial Cyr", "Arial","Tahoma","Helvetica", sans-serif;
	color : <?=$constant['header-text-color']?>
}

.headerlink {
	font : 8pt "Verdana","Arial Cyr", "Arial","Tahoma","Helvetica", sans-serif;
	color : <?=$constant['header-link-color']?>
}
-->
</style>
</head>
<body bgcolor="<?=$constant['background-color']?>" text="<?=$constant['text-color']?>" link="<?=$constant['link-color']?>" vlink="<?=$constant['link-color']?>" alink="<?=$constant['link-color']?>" leftmargin="0" marginwidth="0" topmargin="0" marginheight="0">
<table width="760" border="0" cellpadding="0" cellspacing="0" align="center" height="100%">
<tr>
	<td valign="top" class="text" height="1%">
		<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td bgcolor="<?=$constant['border-color']?>">
				<table width="100%" border="0" cellpadding="2" cellspacing="1">
				<tr>
					<td bgcolor="<?=$constant['header-background-color']?>" class="headertext" id="book-title">Admbook versi0n <?=$constant['version']?></td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
		<br/>
		<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td bgcolor="<?=$constant['border-color']?>">
				<table width="100%" border="0" cellpadding="2" cellspacing="1">
				<tr>
					<td bgcolor="<?=$constant['header-background-color']?>" class="headertext" align="center"><b>Censored word</b></td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
		<br/>
<?php
	$pageLine = pagesNumber($contentCnt, $messageToPage, $page, "censored.php", $constant['page-in-line'], "page: ", "total: ", "headerlink");
	if ($pageLine != "")
	{
?>		<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td bgcolor="<?=$constant['border-color']?>">
				<table width="100%" border="0" cellpadding="2" cellspacing="1">
				<tr>
					<td bgcolor="<?=$constant['header-background-color']?>" class="headertext"><?=$pageLine?></td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
<?php
	}
	if ($contentCnt > 0)
	{
?>
		<form action="censored-del.php" method="get">
		<input type="hidden" name="page" value="<?=$page?>"/>
		<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td bgcolor="<?=$constant['border-color']?>">
				<table width="100%" border="0" cellpadding="2" cellspacing="1">
<?
		$z = $page*$messageToPage - ($messageToPage-1);
		$currentContent = outputPageContent($censor,$page,$messageToPage);
		for ($i = 0; $i < sizeof($currentContent); $i++)
		{
			if ($inverse)
				$inverse = false;
			else
				$inverse = true;
?>
				<tr bgcolor="<?=$inverse ? $constant['admin-message-background-color'] : $constant['message-background-color']?>">
					<td width="1%"><input type="checkbox" name="id[]" value="<?=$z;?>"/></td>
					<td class="text">&nbsp;<a href="censored-del.php?id=<?=$z?>" class="<?=$inverse ? "adminlink" : "messagelink"?>"><?=$currentContent[$i]?></a></td>
				</tr>
<?php
			$z++;
		}
?>				</table>
			</td>
		</tr>
		</table>
		<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td><img src="../img/sp.gif" width="1" height="5"/></td>
		</tr>
		<tr>
			<td bgcolor="<?=$constant['border-color']?>"><img src="../img/sp.gif" width="1" height="1"/></td>
		</tr>
		<tr>
			<td><img src="../img/sp.gif" width="1" height="5"/></td>
		</tr>
		<tr>
			<td align="right">
				<input type="button" value="check all" class="halfbutton" onClick="javascript:check(true)"/><input type="button" value="uncheck all" class="halfbutton" onClick="javascript:check(false)"/><br/>
				<input type="submit" value="delete" class="button"/>
			</td>
		</tr>
		</table>
		</form>
<?php
	}
	$timer->stop();
?>
	</td>
</tr>
</tr>
	<form action="censored-add.php" method="post">
	<input type="hidden" name="page" value="<?=$page?>"/>
	<td valign="top" align="right">
		<br/>
		<table width="230" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td class="text" nowrap>new censored word:</td>
			<td width="10"><spacer width="10" height="1" type="block"></td>
			<td width="170"><input type="text" size="16" name="word" value="" maxlength="50" class="field"/></td>
		</tr>
		<tr>
			<td colspan="3" height="10"><spacer width="1" height="10" type="block"></td>
		</tr>
		<tr>
			<td colspan="3" align="right"><input type="submit" value="add" class="button"/></td>
		</tr>
		<tr>
			<td colspan="3" align="right"><input type="button" value="back" class="halfbutton" onClick="javascript:window.location.href='index.php?page=<?=$page?>'"/><input type="button" value="logout" class="halfbutton" onClick="javascript:window.location.href='logout.php'"/></td>
		</tr>
		</table>
	</td>
	</form>
</tr>
<tr>
	<td valign="bottom" align="right" height="1">
		<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td width="1%" nowrap><a href="http://faq.saterenko.ru/" class="link">http://faq.saterenko.ru/</a></td>
			<td align="right" class="text" valign="bottom"><span class="text">&copy;&nbsp;</span><a href="mailto:trent@low.ru" class="link">trent</a>&nbsp;<a href="http://www.mycgiserver.com/~sample/" class="text">http://www.mycgiserver.com/~sample/</a>&nbsp;</td>
		</tr>
		</table>
	</td>
</tr>
</table>
<!-- generation time <?=$timer->elapsed()." sec";?> -->
</body>
</html>